/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.util.chinese;

import com.jiuqi.util.chinese.NoValidCharException;

public class StringSplitor {
    private final char[] CHARS;
    private int position;
    private int nextPosition;
    private final char[] EXCLUDE_SET;

    public StringSplitor(String value, char[] excludSet) {
        if (value == null) {
            throw new IllegalArgumentException("指向空的字符串指针！");
        }
        this.CHARS = value.toCharArray();
        this.position = -1;
        this.nextPosition = -1;
        this.EXCLUDE_SET = excludSet;
    }

    public boolean isValidChar(char theChar) {
        boolean found = false;
        int i = 0;
        while (i < this.EXCLUDE_SET.length) {
            if (this.EXCLUDE_SET[i] == theChar) {
                found = true;
                break;
            }
            ++i;
        }
        return !found;
    }

    public boolean hasValidChar() {
        if (this.position == this.CHARS.length - 1) {
            return false;
        }
        if (this.nextPosition > this.position) {
            return true;
        }
        int i = this.position + 1;
        while (i < this.CHARS.length) {
            char thisChar = this.CHARS[i];
            if (this.isValidChar(thisChar)) {
                this.nextPosition = i;
                return true;
            }
            ++i;
        }
        return false;
    }

    public char getNextValidChar() throws NoValidCharException {
        if (this.hasValidChar()) {
            this.position = this.nextPosition;
            return this.CHARS[this.position];
        }
        throw new NoValidCharException("这个字符串已经没有非空格的字符！");
    }

    public void rollBack() {
        boolean found = false;
        int prePosition = this.position - 1;
        while (prePosition >= 0) {
            if (this.isValidChar(this.CHARS[prePosition])) {
                found = true;
                break;
            }
            --prePosition;
        }
        this.position = found ? prePosition : -1;
        this.nextPosition = this.position;
    }

    public String getLeft() {
        return new String(this.CHARS, this.position + 1, this.CHARS.length - this.position - 1);
    }

    public int validLength() {
        int length = 0;
        int i = 0;
        while (i < this.CHARS.length) {
            if (this.isValidChar(this.CHARS[i])) {
                ++length;
            }
            ++i;
        }
        return length;
    }
}

